/*
                                 Visual FX
                                    For
                                 Image FX
                               SetUp Script
                           Written By J.L. White

                         (C)1997 Merlin's Software

*/
signal on error
signal on syntax

parse arg CurrentFX VolumeNum TotalNum Frames Fields
options results
Quote = '22'X

address "IMAGEFX.1"
ScreenToFront
FlyOn = 0
Compression = -1
Frames = strip(Frames)
Fields = strip(Fields)




call FXSetUp()

if exists("libs:flyer.library") then do
	if (POS('PROJECT_REXX_PORT',SHOW('Ports')) =0) then do
		RequestNotify 'Flyer Must Be Running First!'
		exit
		end
	call OpenFlyStuff()
	Title = "Effect #"right(CurrentFX,2,'0')" From Volume #"strip(VolumeNum)
	Gadget.1 = 'X/258/20/Use Field Rendering?/'Fields
	Gadget.2 = 'D/78/20/120/Save As/2/FLYER CLIP/SEQUENCE'
	Gadget.3 = 'L/135/42/1/2/'Title
	ComplexRequest  '"Visual FX  SetUp Options"' 3 Gadget 450 56
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		Field = RESULT.1
		SaveType = RESULT.2
   		end
	end
else do
	Title = "Effect #"right(CurrentFX,2,'0')" From Volume #"strip(VolumeNum)
	Gadget.1 = 'X/154/20/Use Field Rendering?/Fields'
	Gadget.2 = 'L/150/42/1/2/'Title
	ComplexRequest  '"Visual FX  SetUp Options"' 2 Gadget 480 56
	if rc ~= 0 then do
		exit 0
		end
	else do
		Frames = RESULT.1
		Field = RESULT.2
		SaveType = 1
   		end
end

call GetS()
call SaveTemp()

if FlyOn = 1 then
	call CloseStuff()
ScreenToBack
EXIT 0


FXSetUp:
	FXSName = "VFXIFX:SetUp/"right(strip(VolumeNum),2,'0')"/"right(strip(CurrentFX),2,'0')".rexx"
	if exists(FXSName) then do
		address command "sys:rexxc/rx >NIL: "FXSName" "strip(TotalNum)".txt "Frames
		end
return


FindDrive:
	address command "C:Info >RAM:DriveList"
	call open TempFile,"RAM:DriveList",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line Drive" "Rest
		if Drive = "FA0:" then 
			FlyVolume = word(Rest,7)":"
	end
	call close TempFile
	address command "Delete >NIL: RAM:DriveList"
return FlyVolume


OpenFlyStuff:
	FlyOn = 1
	address command "run VFXIFX:FLY" 
	do while (POS('FLY_1',SHOW('Ports')) = 0)
		address command "wait 1"
		end
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	DriveName = FindDrive()
return


GetFile:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetFileNameNT Title
return result

YesOrNo: procedure
	parse Arg Title,Yes,No
	Address FLY_1 OK_TEXT Yes
	Address FLY_1 CANCEL_TEXT No
	Address FLY_1 AskYesNoNT Title
	if result = "OK" then YesNo = 1
	else YesNo = 0
return YesNo


GetSName:
	SaveName = GetFile("Enter Flyer Clip Name To Save!  ",DriveName)
	Name = GetFileName(SaveName)
	if Name = "" then do
		Address FLY_1 OK_TEXT " OK "
		Title = "You Must Enter A Valid Clip Name To Save!"
		Address FLY_1 FYINT Title
		Address FLY_1 Quit
		call Switcher(TOWB)
		exit
		end
	if exists(SaveName) then do
		Answer = YesOrNo(" Are You Sure You Want To \ OverWrite "SaveName"?"," YES "," NO ")
		if Answer = 0 then do
			call GetSName()
			return
			end
		Answer = YesOrNo(" Are You Positive?"," YES "," NO ")
		if Answer = 1 then do
			address command "Delete >NIL: "SaveName
			if exists(SaveName".I") then
				address command "Delete >NIL: "SaveName".I"
			end
		if Answer = 0 then do
			call GetSName()
			return
			end

		end
return


GetS:
  if SaveType = 0 then do
	DriveName = FindDrive()
	call Switcher(TOSW)
	call GetSName()
	Address FLY_1 GetCompressionNT
	Compression = result
	if Compression = 2 then Compression = 0
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	call Switcher(TOWB)
	address command "C:Wait 1"
	ScreenToFront
	end
   if SaveType = 1 then do
	RequestFile '"Select BaseName To Save "' "SYS:" ' '
	SaveName = result
	Name = GetFileName(SaveName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	end
return

CloseStuff:
	Address FLY_1 Quit
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
return


SaveTemp:
	address command "Copy >NIL: VFXIFX:Arexx/"right(strip(VolumeNum),2,'0')"/"right(strip(CurrentFX),2,'0')".rexx to RAM:VFXTEMP"
	call open TempFile,"Ram:VFXTEMP",A
	call writeln TempFile,"Settings:"
	call writeln TempFile,"   Compression="Compression
	call writeln TempFile,"   Field="Field
	call writeln TempFile,"   SaveType="SaveType
	call writeln TempFile,"   SaveName="Quote""SaveName""Quote
	call writeln TempFile,"   Volume="strip(VolumeNum)
	call writeln TempFile,"   CurrentFX="strip(CurrentFX)
	call writeln TempFile,"   FXNum="strip(TotalNum)
	call writeln TempFile,"return"
	call close TempFile
return

GetPathName: procedure  
   ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return left(CompleteName,c)

GetFileName: procedure  
   ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return substr(CompleteName, c + 1)


syntax:
error:
	Title = "An Error Was Found With This Script On Line #"SIGL"!"
	if SIGL != 35 then RequestNotify Title
	if FlyOn = 1 then
		Address FLY_1 Quit
exit

